import java.io.*;

public class CrashMonitor{
	private static File file, saveDir;
	private static File[] savedFiles;
	private static String loadName;
	
	public static void main(String[] args){
		int minutes = 10;
		String filename = "stat.txt";
		for (int i=0; i<args.length; i++){
			if ("? /? -? h /h -h H /H -H help /help -help hilfe /hilfe -hilfe".indexOf(args[i]) > -1) {
				printHelp();
				System.exit(0);
			}
			else if (args[i].indexOf("-interval:") > -1){
				minutes = Integer.parseInt(args[i].substring(10), 10);
			}
			else if (args[i].indexOf("-filename:") > -1){
				filename = args[i].substring(10);
			}
		}
		looping(minutes, filename);
	}
	
	private static void looping(int minutes, String filename){
		String command;
		String tempName;
		int i, j;
		while (true){
			try{
				file = new File("simulationOk");
				file.delete();
				Thread.sleep(minutes*1000*60);
				if (file.exists()){
					//dann ist alles ok
				}
				else{
					System.out.print("restarting ");
					saveDir = new File("save");
					savedFiles = saveDir.listFiles();
					if (savedFiles.length == 0){
						System.out.println("problems: the save directory is empty.");
						System.exit(1);
					}					
					loadName = null;
					i = 0;
					while (loadName == null){
						tempName = savedFiles[i].getName();
						if (tempName.startsWith("autosave")){
							loadName = tempName;
						}
						else {
							i++;
							if (i==savedFiles.length) {//immer noch keinen gefunden
								System.out.println("problems: the save directory does not contain any autosave files.");
								System.exit(1);
							}
						}
					}
					for (j=i; i<savedFiles.length; i++){
						tempName = savedFiles[i].getName();
						if (tempName.compareTo(loadName) > 0  &&  tempName.startsWith("autosave")){
							loadName = tempName;
						}
					}
					System.out.println(loadName);
					command = "java SimStart -statappend:" + filename + " -run:save";
					command = command + System.getProperty("file.separator") +loadName;
					Runtime.getRuntime().exec(command);
				}
			}
			catch(Exception e){
				System.out.println(e);
			}
		}
	}
	
	private static void printHelp(){
		System.out.println("Ueberwacht eine Simulation, die im gleichen Verzeichnis gestartet wurde.");
		System.out.println("Als Parameter kann ein Integer angegeben werden, der die Intervalle");
		System.out.println("in Minuten angibt, 10 Minuten ist default.");
		System.out.println("Wenn innerhalb der angebenen Zeit keine Simulationsrunde vollendet wird,");
		System.out.println("dann wird die Simulation wieder gestartet. Dabei wird die lexikalisch");
		System.out.println("groesste Datei aus dem save Ordner geladen und die Statistik in der");
		System.out.println("Datei stat.txt weitergefuehrt.");
	}
}
		  	  
	