import java.io.*;
import java.util.*;

/**
 * Stellt die frs Pflanzenwachstum bentigte Funktionalitt.
**/
public class GrowFunction implements Serializable{
	/** Wird dieser Wert unterschritten, findet kein Wachstum statt. **/
	private static float min;
	/** Das maximum an Nahrung, das sich auf einem Feld befinden kann. **/
	private static float max;
	/** Der Zuwachs an Nahrung pro Runde (falls min <= food <= max-inc). **/
	private static float inc;
	
	public static void init(){
		min = World.getFloat("GF.min");
		max = World.getFloat("GF.max");
		inc = World.getFloat("GF.inc");
	}
	
	/** 
	 * Liefert den Nahrungszuwachs bei gegebenem aktuellen Bestand.
	 * Falls dieser (durch Samenflug) den Wert max berschreitet, kann
	 * der Returnwert auch negativ sein. 
	**/
	public static float foodInc(float food){
		if (food < min){
			return(0);
		}
		else if (food >= min && food <= (max-inc)){
			return(inc);
		}
		else{ //food > max-inc
			return(max - food);
		}
	}
	
	public static float getMin(){
		return(min);
	}
	public static float getMax(){
		return(max);
	}
	public static float getInc(){
		return(inc);
	}
}