import java.io.*;

/**
 * Speichert die Information eines Feldes im Gedaechnis des Agenten.
**/
public class MemoryField implements Serializable{
	
	/**
	 * die beobachtete Nahrungsmenge.
	**/
	private float food;
	
	/**
	 * der Name des Agenten auf dem Feld, oder null.
	**/
	private String agentName;
	/**
	 * der Agent auf dem Feld, oder null.
	**/
	private Agent agent;
	/**
	 * der Stand des Rundenzaehlers zur Zeit der Beobachtung.
	**/
	private int date;
	
	/**
	 * Schafft ein MemoryField mit den uebergebenen Werten.
	 * @param food ein int, der die beobachtete Menge an Nahrung angibt.
	 * @param agentName ein StingBuffer mit dem Namen des Agenten der auf dem Feld gesehen wurde. Null falls keiner.
	 * @param date int, der den Stand des Rundenzaehlers zur Zeit der Beobachtung anzeigt. 
	**/
	public MemoryField(float food, Agent agent, String agentName, int date){
		this.food = food;
		this.agent = agent;
		this.agentName = agentName;
		this.date = date;
	}
	
	public boolean update(MemoryField mf){
		if (date < mf.date){
			food = mf.food;
			agent = mf.agent;
			agentName = mf.agentName;
			date = mf.date;
			return(true);
		}
		else{
			return(false);
		}
	}
	
	/**
	 * @return die "gemerkte" Nahrungsmenge
	**/
	public float getFood(){
		return(food);
	}
	
	/**
	 * @return der "gemerkte" Name des Agenten
	**/
	public String getAgentName(){
		return(agentName);
	}
	
	/**
	 * @return der "gemerkte" Agent
	**/
	public Agent getAgent(){
		return(agent);
	}
	/**
	 * @return das "Datum" (Stand des Rundenzaehlers) der Beobachtung
	**/
	public int getDate(){
		return(date);
	}
	
	public void setFood(float food){
		this.food = food;
	}
	
	public void setAgent(Agent agent){
		this.agent = agent;
	}
	public void setAgentName(String agentName){
		this.agentName = agentName;
	}
	
	public void setDate(int date){
		this.date = date;
	}
}