import javax.swing.*;
import java.awt.event.*;
import java.awt.*;

public class MemoryMonitor extends Frame implements WindowListener {
	
	private World world;
	private Agent agent;
	private Memory memory;
	private TorusView torusView;
	
	public MemoryMonitor(Agent a){
		setTitle("Memory of Agent: " + new String(a.getName()));
		agent = a;
		memory = agent.getMemory();
		setLayout(new BorderLayout());
		torusView = new TorusView(memory);
		add(torusView, BorderLayout.CENTER);
		setSize(World.getInt("MemoryMonitor.width"), World.getInt("MemoryMonitor.height"));
		addWindowListener(this);
	}
	
	public void update(){
		Graphics g = torusView.getGraphics();
		torusView.paint(g);
	}
	public void updateField(int x, int y){
//		torusView.paintMemoryField(memory, x, y);
	}
			
	public void windowClosing(WindowEvent e){
		agent.removeMemoryMonitor();
		dispose();
	}
	public void windowOpened(WindowEvent e){}
	public void windowClosed(WindowEvent e){}
	public void windowIconified(WindowEvent e){}
	public void windowDeiconified(WindowEvent e){}
	public void windowActivated(WindowEvent e){}
	public void windowDeactivated(WindowEvent e){}
}