import java.awt.*;
import java.awt.event.*;

/**
 * Die Menubar fr ein WorldView Fenster.
**/
public class MyMenuBar extends MenuBar implements ActionListener, ItemListener{
	private Menu fileMenu = new Menu("File");
	private MenuItem loadMItem = new MenuItem("Load");	
	private MenuItem saveMItem = new MenuItem("Save as...");
	private MenuItem exitMItem = new MenuItem("Exit");
	
	private Menu editMenu = new Menu("Edit");
	private MenuItem agentMItem = new MenuItem("Place/Remove Agent");	
	private MenuItem foodMItem = new MenuItem("Food");
	private CheckboxMenuItem paintFoodCBMItem = new CheckboxMenuItem("Paint Food");
	
	private Menu monitorMenu = new Menu("Monitor");
	private MenuItem aValuesMItem = new MenuItem("Agent Values");
	private MenuItem memoryMItem = new MenuItem("Memory");

	private Menu systemMenu = new Menu("System");
	private MenuItem agentTreeMItem = new MenuItem("Agent Tree");
	private MenuItem editPropsMItem = new MenuItem("Edit Properties");

	private Menu helpMenu = new Menu("Help");
	private MenuItem helpMItem = new MenuItem("Help");
		
	/**
	 * Schafft die Menubar mit allen Teilen.
	**/
	public MyMenuBar(){ 
		loadMItem.addActionListener(this);
		saveMItem.addActionListener(this);
		exitMItem.addActionListener(this);
		fileMenu.add(loadMItem);
		fileMenu.add(saveMItem);
		fileMenu.add(new MenuItem("-"));
		fileMenu.add(exitMItem);
		this.add(fileMenu);

		agentMItem.addActionListener(this);
		foodMItem.addActionListener(this);
		paintFoodCBMItem.addItemListener(this);		
		editMenu.add(agentMItem);
		editMenu.add(foodMItem);
		editMenu.add(paintFoodCBMItem);
		this.add(editMenu);
		
		aValuesMItem.addActionListener(this);
		memoryMItem.addActionListener(this);		
		monitorMenu.add(aValuesMItem);
		monitorMenu.add(memoryMItem);
		this.add(monitorMenu);

		agentTreeMItem.addActionListener(this);
		editPropsMItem.addActionListener(this);
		systemMenu.add(agentTreeMItem);
		systemMenu.add(editPropsMItem);
		this.add(systemMenu);
		
		helpMItem.addActionListener(this);
		helpMenu.add(helpMItem);
		this.add(helpMenu);
	}
	
	public void setEditEnabled(boolean b){
		fileMenu.setEnabled(b);
		editMenu.setEnabled(b);
		systemMenu.setEnabled(b);
		monitorMenu.setEnabled(b);
	}
	public void setMonitorEnabled(boolean b){
		monitorMenu.setEnabled(b);
	}
	
	public void itemStateChanged(ItemEvent e){
		if (e.getItem().equals("Paint Food")){
			if (e.getStateChange() == ItemEvent.SELECTED){
				((WorldView)getParent()).paintFoodOn();
			}
			else{
				((WorldView)getParent()).paintFoodOff();
			}
		}
	}

	/**
	 * Verarbeitet die ausgelsten Actions (Menu-Befehle).
	**/
	public void actionPerformed(ActionEvent e){
		if (e.getActionCommand().equals("Exit")){
			try{
				Thread.sleep(2300);
			} 
			catch(Exception x){}
			System.exit(0);
		}
		else if (e.getActionCommand().equals("Save as..."))
			((WorldView)getParent()).saveWorld();
		else if (e.getActionCommand().equals("Load"))
			((WorldView)getParent()).loadWorld();
		else if (e.getActionCommand().equals("Place/Remove Agent"))
			((WorldView)getParent()).editAgent();
		else if (e.getActionCommand().equals("Food"))
			((WorldView)getParent()).editFood();
		else if (e.getActionCommand().equals("Food100"))
			((WorldView)getParent()).editFood100();
		else if (e.getActionCommand().equals("Agent Values"))
			((WorldView)getParent()).setAgentMonitor();	
		else if (e.getActionCommand().equals("Memory"))
			((WorldView)getParent()).setMemoryMonitor();	
		else if (e.getActionCommand().equals("Agent Tree"))
			((WorldView)getParent()).showAgentTree();	
		else if (e.getActionCommand().equals("Edit Properties"))
			((WorldView)getParent()).editProps();
		else if (e.getActionCommand().equals("Slow Down"))
			((WorldView)getParent()).slowDown();
		else if (e.getActionCommand().equals("Help"))
			((WorldView)getParent()).showHelp();
	}
}