import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.io.*;

/**
 * Dies Panel nimmt diverse Buttons auf, die die Simulation steuern.
 * Es ist in einem WorldView-Frame angesiedelt.
 */
public class SimControl extends Panel implements ActionListener{
	private Button stopButton = new Button("stop");
	private Button stepButton = new Button("step");
	private Button goButton   = new Button("go");
	private Label roundLabel = new Label("      0", Label.RIGHT);

	/**
	 * Schafft ein neues SimControl und setzt dessen Einstellungen.
	**/
	public SimControl(){
		this.setLayout(new FlowLayout());
		this.add(stopButton);
		this.add(stepButton);
		this.add(goButton);	
		this.add(roundLabel);

		stopButton.addActionListener(this);
		stopButton.setEnabled(false);
		goButton.addActionListener(this);
	}
	
	public void addListener(ActionListener al){
		stopButton.addActionListener(al);
		stepButton.addActionListener(al);
		goButton.addActionListener(al);
	}
	
	public void updateRound(int r){
		roundLabel.setText((new Integer(r)).toString());
	}
	
	public void setEditMode(boolean b){
		stopButton.setEnabled(!b);
		stepButton.setEnabled(b);
		goButton.setEnabled(b);
	}
	/**
	 * Verarbeitet die Ereignisse, die innerhalb der SimControl 
	 * erzeugt werden.
	 * @param e das Event, das erzeugt wird
	**/
	public void actionPerformed(ActionEvent e){
		if (e.getActionCommand().equals("stop")){
			stopButton.setEnabled(false);
			goButton.setEnabled(true);			
			stepButton.setEnabled(true);
			goButton.requestFocus();
		} 
		else if (e.getActionCommand().equals("go")){
			stopButton.setEnabled(true);
			stepButton.setEnabled(false);
			stopButton.requestFocus();
			goButton.setEnabled(false);
		}
		else {
			System.out.println("in SimControl.actionPerformed: unknownActionCommand: " + e);
		}
	}
}