import java.applet.*;
import java.util.*;
import java.io.*;

/**
 * Dient dem Starten des Programms, enthlt die main-Methode frs Projekt.
**/
public class SimStart{
	
	/**
	 * Die main-Methode des Projekts. Mit ihr wird alles gestartet.
	 * @param args die Kommandozeilenparameter. java SimStart -? gibt Hilfestellung.
	**/
	public static void main(String[] args){
		
		//check jvm-version
		String version = System.getProperty("java.version");
		if (version.compareTo("1.2") < 0){
			System.out.println();
			System.out.println(">> Warning <<");
			System.out.println();
			System.out.println("Version: " + version + " detected.");
			System.out.println("This program needs 1.2 or compatible higher version.");
			System.out.println("Problems are probable...");
			System.out.println();
		}
		
		//parse commandline parameters
		World.maxRound = 0;  //default (off)
		World.sound = false;  //default
		World.debug = false;  //default
		World.silent = false; //default
		World.loadFile = null;//default
		World.runFile = false;//default
		for (int i=0; i<args.length; i++){
			if ("? /? -? h /h -h H /H -H help /help -help hilfe /hilfe -hilfe".indexOf(args[i]) > -1) {
				printHelp();
				System.exit(0);
			}
			else if (args[i].indexOf("-config:") > -1){
				World.configFile = args[i].substring(8);
			}
			else if (args[i].indexOf("-load:") > -1){
				World.loadFile = args[i].substring(6);
			}
			else if (args[i].indexOf("-run:") > -1){
				World.loadFile = args[i].substring(5);
				World.runFile = true;
			}
			else if (args[i].indexOf("-run") > -1){
				World.runFile = true;
			}
			else if (args[i].indexOf("-stat:") > -1){
				Stat.setFile(args[i].substring(6), false);
			}
			else if (args[i].indexOf("-statappend:") > -1){
				Stat.setFile(args[i].substring(12), true);
			}
			else if (args[i].indexOf("-rounds:") > -1){
				World.maxRound = Integer.parseInt(args[i].substring(8));
			}
			else if (args[i].equalsIgnoreCase("-sound")){
				World.initAudioClips();
				World.sound = true;
			}
			else if (args[i].equalsIgnoreCase("-debug")){
				World.debug = true;
			}
			else if (args[i].equalsIgnoreCase("-decimal:comma")){
				World.decimal = "comma";
			}
			else if (args[i].equalsIgnoreCase("-decimal:point")){
				World.decimal = "point";
			}
			
			else{
				System.out.println("Error in commandline. Type");
				System.out.println("java SimStart -? ");
				System.out.println("for help");
				System.exit(1);
			}
		}
		if (args.length == 0){
			printHelp();
			System.out.println("starting program ...");
		}

		WorldView v;
		World w;
		Agent a;
		Scheduler s;
		if (World.configFile != null){
			w = new World(World.configFile);
		}
		else {
			w = new World("props.config");
		}
		GrowFunction.init();
		s = new Scheduler();
		v = new WorldView(w);
		v.setScheduler(s);
		s.setWorldView(v);
		World.worldView = v;
		s.start();
		v.show();
		if (World.loadFile != null){
			v.loadWorld(World.loadFile);
		}
		if (World.runFile){
			v.runSim();
		}
	}
	
	public static void printHelp(){
		System.out.println();
		System.out.println("commandlineparameters:");
		System.out.println("");
		System.out.println("-?        prints this info and ends");
		System.out.println("-config:  uses the specified file as coniguration");
		System.out.println("-load:    loads the specified file as World");
		System.out.println("-run:     loads the specified file as World and starts simulating");
		System.out.println("-run      starts the simulation of the world described in the config file");
		System.out.println("-stat:    writes statistics to the specified new file");
		System.out.println("-statappend:      appends statistics to the specified file");
		System.out.println("-rounds:  terminates the program after simulating reaches round NNNN");
		System.out.println("-debug    turns on debug mode (to enable further information output)");
		System.out.println("-sound    turns on sound (default is off)");
		System.out.println("-decimal:comma    statistic output with decimalcomma");
		System.out.println("-decimal:point    statistic output with decimalpoint");
		System.out.println("");
		System.out.println("FILE  name and path of a file to use");
		System.out.println("use absolute or relative path (relative to program location)");
		System.out.println("do not use file- or pathnames with spaces");
	}
}