import java.util.*;
import java.io.*;

public class Stat{
	
	private static Vector livingAgents;
	private static PrintStream printStream;
	private static int numOfFertileFields;
	private static float sumFood;

	public static void newRound(){
		livingAgents = new Vector();
		numOfFertileFields = 0;
		sumFood = 0;
	}
	public static void addAgent(Agent a){
		livingAgents.add(a);
	}
	public static void addFoodField(float food){
		numOfFertileFields++;
		sumFood = sumFood + food;
	}
	public static void endRound(){
		if (printStream == null) {return;} // dann macht das Folgende keinen Sinn
		StringBuffer output = new StringBuffer();
		float sumAllAgentsFood = 0;
		float sumNormsAgentsFood = 0;
		float sumKoordsAgentsFood = 0;
		float sumSubsAgentsFood = 0;
		float sumAllAge = 0;
		float sumNormsAge = 0;
		float sumKoordsAge = 0;
		float sumSubsAge = 0;
		float sumAllChildren = 0;
		float sumNormsChildren = 0;
		float sumKoordsChildren = 0;
		float sumSubsChildren = 0;
		float allAgents = (float)livingAgents.size();
		float norms = 0;
		float koords = 0;
		float subs = 0;
		float koordsZeroSubs = 0;
		float koordsOneSub = 0;
		float koordsMoreSubs = 0;
		float subsNoKoord = 0;
		float[] mutables = new float[13];
		
		Agent a;
		for (int i=0; i<allAgents; i++){
			a = (Agent)livingAgents.elementAt(i);
			sumAllAgentsFood = sumAllAgentsFood + a.getFood();
			sumAllAge = sumAllAge + a.getAge();
			sumAllChildren = sumAllChildren + a.getNumOfChildren();
			if (a.isCoordinator()){
				koords = koords +1;
				sumKoordsAgentsFood = sumKoordsAgentsFood + a.getFood();
				sumKoordsAge = sumKoordsAge + a.getAge();
				sumKoordsChildren = sumKoordsChildren + a.getNumOfChildren();
				int numOfSubs = a.getNumOfSubordinates();
				if (numOfSubs == 0){
					koordsZeroSubs++;
				}
				else if (numOfSubs == 1){
					koordsOneSub++;
				}
				else {
					koordsMoreSubs++;
				}
			}
			else if (a.hasCoordinator()){
				subs = subs + 1;
				sumSubsAgentsFood = sumSubsAgentsFood + a.getFood();
				sumSubsAge = sumSubsAge + a.getAge();
				sumSubsChildren = sumSubsChildren + a.getNumOfChildren();
			}
			else{
				norms = norms + 1;
				sumNormsAgentsFood = sumNormsAgentsFood + a.getFood();
				sumNormsAge = sumNormsAge + a.getAge();
				sumNormsChildren = sumNormsChildren + a.getNumOfChildren();
			}
			if (a.hasTarget() && !a.hasCoordinator()){
				subsNoKoord++;
			}
			float[] tempMut = a.getMutableValues();
			for(int j=0; j<13; j++){
				mutables[j] = mutables[j] + tempMut[j];
			}
		}
		
		for(int i=0; i<13; i++){
			mutables[i] = mutables[i] / allAgents;
		}

		if (allAgents == 0) {return;} // dann gibts auch nichts zu berichten
		output.append(World.round);
		output.append(" ");
		output.append(allAgents);
		output.append(" ");
		output.append(sumAllAgentsFood / allAgents);
		output.append(" ");
		output.append(sumAllAge / allAgents);
		output.append(" ");
		output.append(sumAllChildren / allAgents);
		output.append(" ");
		if (norms > 0){
			output.append(norms);
			output.append(" ");
			output.append(sumNormsAgentsFood / norms);
			output.append(" ");
			output.append(sumNormsAge / norms);
			output.append(" ");
			output.append(sumNormsChildren / norms);
			output.append(" ");
		}
		else{
			output.append("0 0 0 0 ");
		}

		if (koords > 0){
			output.append(koords);
			output.append(" ");
			output.append(sumKoordsAgentsFood / koords);
			output.append(" ");
			output.append(sumKoordsAge / koords);
			output.append(" ");
			output.append(sumKoordsChildren / koords);
			output.append(" ");
		}
		else{
			output.append("0 0 0 0 ");
		}
		
		if (subs > 0){
			output.append(subs);
			output.append(" ");
			output.append(sumSubsAgentsFood / subs);
			output.append(" ");
			output.append(sumSubsAge / subs);
			output.append(" ");
			output.append(sumSubsChildren / subs);
		}
		else{
			output.append("0 0 0 0");
		}
		output.append(" ");
		output.append(koordsZeroSubs);
		output.append(" ");
		output.append(koordsOneSub);
		output.append(" ");
		output.append(koordsMoreSubs);
		output.append(" ");
		output.append(subsNoKoord);
		output.append(" ");
		output.append(numOfFertileFields);
		output.append(" ");
		output.append(sumFood);
		
		for(int i=0; i<13; i++){
			output.append(" ");
			output.append(mutables[i]);
		}
		
		if (World.decimal != null && World.decimal.equals("comma")){
			printStream.println(output.toString().replace('.', ','));
		}
		else if (World.decimal != null && World.decimal.equals("point")){
			printStream.println(output.toString().replace(',', '.'));
		}
		else{
			printStream.println(output.toString());
		}
	}
	public static void setFile(String filename, boolean append){
		try{
			//autoflush on
			printStream = new PrintStream(new FileOutputStream(filename, append), true);
			if (append == false){
				printStream.print("round numAll avAllFood avAllAge avAllChildren ");
				printStream.print("numNorms avNormsFood avNormsAge avNormsChildren ");
				printStream.print("numKoords avKoordsFood avKoordsAge avKoordsChildren ");
				printStream.print("numSubs avSubsFood avSubsAge avSubsChildren ");
				printStream.print("koordsZeroSubs koordsOneSub koordsMoreSubs subsNoKoord ");
				printStream.print("fertileFields sumFood eatFoodPR pubertyAge gatherAmount ");
				printStream.print("gatherRest childFood memoryMaxAge viewingRange planningRange ");
				printStream.print("survivalWeight wealthWeight curiosityWeight breedingWeight ");
				printStream.println("influenceWeight");
			}
		}
		catch(Exception e){
			System.out.println("in Stat.setFile: " + e);
		}
	}
}