import java.net.*;
import javax.swing.*;
import javax.swing.event.*;

public class HelpView extends JFrame implements HyperlinkListener{
	private JEditorPane htmlView;
	private JScrollPane scrollPane;

	public HelpView(){
		super("Help");
		htmlView = new JEditorPane();
		scrollPane = new JScrollPane(htmlView);
		htmlView.setEditable(false);
		getContentPane().add(scrollPane);
		
		String s = "file:" 
			+ System.getProperty("user.dir")
			+ System.getProperty("file.separator")
			+ "help"
			+ System.getProperty("file.separator")
			+	"index.htm";
  		
		setHelpPage(s);
		htmlView.addHyperlinkListener(this);
		setSize(400, 300);
		show();
	}
	
	public void setHelpPage(String p){
		try{
			htmlView.setPage(p);
		}
		catch(Exception e){
			System.out.println("in HelpView.setHelpPage: " + e);
		}
	}
	public void setHelpPage(URL p){
		try{
			htmlView.setPage(p);
		}
		catch(Exception e){
			System.out.println("in HelpView.setHelpPage: " + e);
		}
	}

	public void hyperlinkUpdate(HyperlinkEvent e){
		if (e.getEventType() == HyperlinkEvent.EventType.ACTIVATED){
			setHelpPage(e.getURL());
		}
	}
}